
$(function(e){

	$(document).on('click', '.ll-ext-popup-footer .start-btn', function(e){
		e.preventDefault();
		faceAnimate($(this).closest('.ll-ext-popup'));
	});

	/* main menu */
    $(document).on('click', '.ll-ext-btn-list [data-popup]', function(e){
    	e.preventDefault();
    	var $this = $(this),
    		$popup = $('#'+$this.attr('data-popup'));

        $this.toggleClass('active').siblings('[data-popup]').removeClass('active');

        if($this.hasClass('active')){
        	showPopup($popup, $this);

        }else{
        	hidePopup($popup);
        }
    });


    /* hide popup */
    $(document).on('click', '.ll-ext-popup-btn.cancel-btn', function(e){
    	e.preventDefault();

        hidePopup($(this).closest('.ll-ext-popup'));
        $('.ll-ext-btn-list [data-popup]').removeClass('active');
    });


    /* show error */
    $(document).on('click', '.ll-ext-popup-btn.start-btn', function(e){
    	e.preventDefault();

        $(this).closest('.ll-ext-popup').find('.ll-ext-required textarea').each(function(){
        	var $this = $(this),
        		templateSelected = $this.closest('.ll-ext-tabs-contents').find('.ll-ext-template-item.active').length;

        	if(!$this.val().length && !templateSelected){
        		$this.closest('.ll-ext-required').addClass('show-error');

	        	var index = $this.closest('.ll-ext-tabs-contents').find('.ll-ext-tabs-content').index($this.closest('.ll-ext-tabs-content'));

	        	$this.closest('.ll-ext-tabs-wrapper').find('.ll-ext-tabs-labels a:eq('+index+')').click();

	        }

        });
    });


    /* hide error */
    $(document).on('focus', '.ll-ext-required textarea', function(e){
        $(this).closest('.ll-ext-required').removeClass('show-error');
    });


	/* treat input */
	$(document).on('keypress', '.ll-ext-popup-treat input', function(e){
		e = e || event;
		if (e.ctrlKey || e.altKey || e.metaKey) return;  
		var chr = getChar(e);
		if (chr == null) return;
		if (chr < '0' || chr > '9') {
			return false;
		}
	});

	$(document).on('keyup', '.ll-ext-popup-treat input', function(e){
		var $this = $(this),
			min = parseInt($this.attr('data-min')),
			max = parseInt($this.attr('data-max')),
			val = $this.val();
			
		if(val<min){
			val = min;
			$this.val(val);
		}else if(val>max){
			val = max;
			$this.val(val);	
		}else if(val.substring(0, 1) == 0){
			val = val.substring(1, 4);
			$this.val(val);	
		}


		$this.closest('.ll-ext-popup').find('.ll-ext-popup-slider-val').text(val);

		$this.closest('.ll-ext-popup').find('.ll-ext-popup-slider').slider('value',val);
	});


	/* length counter */
	$(document).on('input', '.ll-ext-textarea-wrapper textarea', function(e){
		var $this = $(this),
			length = $this.val().length;

		if($this.closest('.ll-ext-textarea-wrapper').find('.ll-ext-maxlength').length){
			$this.closest('.ll-ext-textarea-wrapper').find('.ll-ext-maxlength span').text(length);
		}
	});


	/* vars */
	$(document).on('click', '.ll-ext-vars a', function(e){
		var $this = $(this),
			$textarea = $this.closest('.ll-ext-tabs-content').find('textarea'),
			val = $this.attr('data-var');

		insertAtCaret($textarea, val);

		if($this.closest('.ll-ext-tabs-content').find('.ll-ext-maxlength').length){
			$this.closest('.ll-ext-tabs-content').find('.ll-ext-maxlength span').text($textarea.val().length);
		}
	});


	/* tabs */
	$(document).on('click', '.ll-ext-tabs-wrapper .ll-ext-tabs-labels a', function(e){
		e.preventDefault();

        var $this = $(this),
            index = $this.closest('.ll-ext-tabs-labels').children('a').index($this),
            $tabs = $this.closest('.ll-ext-tabs-wrapper');

        showTab($tabs, index);
    });


	/* template selection */
    $(document).on('click', '.ll-ext-template-item', function(){
        $(this).toggleClass('active').siblings('.ll-ext-template-item').removeClass('active');
    });


    /* tags */
    $(document).on('click', '.ll-ext-tags', function(e){
    	e.preventDefault();
    	$(this).find('input').focus()
    });
 

    $(document).on('click', '.ll-ext-tag span', function(e){
    	e.preventDefault();
    	e.stopPropagation();
    	$(this).closest('.ll-ext-tag').remove();
    });

    $(document).on('keydown', '.ll-ext-tags-add input', function(e){
    	var $this = $(this),
    		$container = $this.closest('.scrollbar-inner');

		if (e.which==13 && $this.val() != '') {
		    e.preventDefault();

			addTag($this, $this.val());
		}

		if (e.keyCode == 8 && $this.val() == '' ) {
		    e.preventDefault();

		    $container.find('.ll-ext-tag:last').remove();
		}

		resizeTagInput($this);
	});

    $(document).on('blur', '.ll-ext-tags-add input', function(e){
    	var $this = $(this);

		if ($this.val() != '') {
		    e.preventDefault();

			addTag($this, $this.val());
		}

		resizeTagInput($this);
	});
});

var availableTags = [
	"tag",
	"tag",
	"tag",
	"tag",
	"tag",
	"tag",
	"tag",
	"tag",
	"long-tag-long-tag"
];

function initTagAutocomplete(input){
	var $input = input,
		$wrapper = $input.closest('.ll-ext-tags').find('.ll-ext-autocomplete-wrapper'),
		$scroll = $wrapper.find('.scrollbar-inner');

	$input.autocomplete({
		source: availableTags,
		appendTo: $scroll.find('.scroll-content'),
		open: function() {
			var $this = $(this),
				left = $this.position().left,
				top = $this.position().top + $this.height()+5;

			$wrapper.show().css({
				left: left,
				top: top 
			})
			$wrapper.find(".ui-autocomplete").css({
				left: 0,
				top: 0,
				width: '100%'
			});
			$scroll.scrollbar();
		},
		select: function( event, ui ) {
			addTag($input, ui.item.value)
			resizeTagInput($input);
			return false;
		},
		close: function(){
			$wrapper.hide();
		}
    });
};

function showPopup(popup, item){
	var left = item.offset().left - (popup.outerWidth() - item.outerWidth()) / 2;

	left = (left+popup.outerWidth()<$('.ll-ext-btn-wrapper').width()) 
			? left
			: $('.ll-ext-btn-wrapper').width()-popup.outerWidth();

	$('.ll-ext-popup').removeClass('active');

    popup.addClass('active');
    popup.css('left', left);
    popup.find('.scrollbar-inner').scrollbar();

	initRangeSlider(popup);

	if(popup.find('.ll-ext-tags-wrapper').length){
		var input = popup.find('.ll-ext-tags-add input');
		initTagAutocomplete(input);
	}

	if(popup.find('.ll-ext-textarea-wrapper').length){
		popup.find('.ll-ext-textarea-wrapper').resizable();
		popup.find('.ll-ext-textarea-wrapper textarea').addClass('textarea-scrollbar').scrollbar();
	}
};

function hidePopup(popup){
	popup.removeClass('active');
};

function addTag(input, val){
	var $this = input;

	$this.closest('.ll-ext-tags-add').before('<div class="ll-ext-tag">'+val+'<span></span></div>');
	$this.val('');

	$this.autocomplete("close");

	$this.closest('.scrollbar-inner').scrollTop($this.closest('.scroll-wrapper').height());
};

function resizeTagInput(input){
	var $input = input,
		$helper = $input.closest('.ll-ext-tags-wrapper').find('.tag-input-helper'),
		maxWidth = $input.closest('.ll-ext-tags').width()-10,
		val = $input.val(),
		escaped = val.replace(/&/g, '&amp;').replace(/\s/g,' ').replace(/</g, '&lt;').replace(/>/g, '&gt;'),
		newWidth = 0;

	$helper.html(escaped);

	newWidth = $helper.width()+20;

	newWidth = (newWidth<=maxWidth)?newWidth:maxWidth;

	input.width(newWidth);
};

function initRangeSlider(slider){
	var $slider = slider.find('.ll-ext-popup-slider'),
		start = parseInt($slider.attr('data-val')),
		min = parseInt($slider.attr('data-min')),
		max = parseInt($slider.attr('data-max')),
		$valueCont = $slider.siblings('.ll-ext-popup-slider-val'),
		$treat = $slider.closest('.ll-ext-popup').find('.ll-ext-popup-treat input');

	$slider.slider({
		range: "min",
		value: start,
		min: min,
		max: max,
		create: function( event , ui ) {
			$valueCont.text(start);
			$treat.val(start);
		},
		slide: function( event, ui ) {
			$valueCont.text(ui.value);
			$treat.val(ui.value);
		}
	});
};

function getChar(event) {
	if (event.which == null) {
		if (event.keyCode < 32) return null;
		return String.fromCharCode(event.keyCode)
	}

	if (event.which!=0 && event.charCode!=0) {
		if (event.which < 32) return null;
		return String.fromCharCode(event.which)
	}

	return null;
};

function showTab($tabs, index){
    $tabs.find('.ll-ext-tabs-labels a:eq('+index+')').addClass('active').siblings('a').removeClass('active');
    $tabs.find('.ll-ext-tabs-content:eq('+index+')').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');

	$tabs.find('.ll-ext-tabs-content:eq('+index+') .scrollbar-inner').scrollbar();

};

function insertAtCaret(txtarea, text) {
	var txtarea = txtarea[0],
		scrollPos = txtarea.scrollTop,
		strPos = 0,
		br = ((txtarea.selectionStart || txtarea.selectionStart == '0') ? "ff" : (document.selection ? "ie" : false ) );

	if($(txtarea).val().length+text.length > $(txtarea).attr('maxlength')) return false;

	if (br == "ie") {
		txtarea.focus();
		var range = document.selection.createRange();
		range.moveStart ('character', -txtarea.value.length);
		strPos = range.text.length;
	} else if (br == "ff") {
		strPos = txtarea.selectionStart;
	}

	var front = (txtarea.value).substring(0, strPos),
		back = (txtarea.value).substring(strPos, txtarea.value.length);

	txtarea.value = front + text + back;
	strPos = strPos + text.length;

	if (br == "ie") {
		txtarea.focus();
		var ieRange = document.selection.createRange();
		ieRange.moveStart ('character', -txtarea.value.length);
		ieRange.moveStart ('character', strPos);
		ieRange.moveEnd ('character', 0);
		ieRange.select();
	} else if (br == "ff") {
		txtarea.selectionStart = strPos;
		txtarea.selectionEnd = strPos;
		txtarea.focus();
	}

	txtarea.scrollTop = scrollPos;
};

function faceAnimate(popup){
	popup.find('.ll-ext-popup-footer').addClass('success');
	setTimeout(function(){
		popup.slideUp(300, function(){
			popup.removeAttr('style').removeClass('active');
			popup.find('.ll-ext-popup-footer').removeClass('success');
		});
		$('.ll-ext-btn-list .ll-ext-btn-item').removeClass('active');
	}, 500);
};