(function ($) {
    'use strict';

    /**
     * ExtSettings constructor
     * @constructor
     */
    function ExtSettings() {

        /* Values for linkedIn oauth */
        var clientId = '78oh2m389bk3nu',
            //scope = 'r_basicprofile',
            scope = 'r_basicprofile%20r_emailaddress',
            redirectUri = 'http://5.9.42.61:3000/api/v1/getUserToken';
        //redirectUri = 'http://5.9.42.61:3000/api/v1/getUserToken';
        //redirectUri = 'http://5.9.42.61:3000/api/v1/getUserToken';

        /* Generate random string for linkedIn ouath */
        function _generateState() {
            function s4() {
                return Math.floor((1 + Math.random()) * 0x10000)
                    .toString(16)
                    .substring(1);
            }

            return s4() + s4() + s4() + s4() + s4() + s4() + s4() + s4();
        }

        /* Show or hide lists */
        function _showHideList($elem, $list, $item, action) {
            if (action == 'saveAs' && ($('#add-tmp-input').val().length == 0 || $('#tmp-body').val().length == 0)) {
                if ($('#add-tmp-input').val() == '') {
                    $('#add-tmp-input').css('border-color', 'red');

                    self.sendMessageToContent({
                        action: 'showSystemNotification',
                        message: 'Empty template subject.'
                    }, null);
                }

                if ($('#tmp-body').val() == '') {
                    $('#tmp-body').css('border-color', 'red');

                    setTimeout(function () {
                        self.sendMessageToContent({
                            action: 'showSystemNotification',
                            message: 'Empty template body.'
                        }, null);
                    }, 1000);
                }

                return;
            }

            if ($list.css('display') == 'none') {
                $list.show();

            } else {
                $list.hide();
            }

            $('html').off('click');
            $('html').one('click', function () { // Clickout for list block
                $list.hide();
            });

            $item.off('click');

            $item.on('click', function () {
                if (action == 'changeSelectValue') { // Change number of users
                    $elem.text($(this).text());
                    self.userData.settings.users = $elem.text();
                    self.saveChanges();

                } else if (action == 'saveAs') { // Saving template
                    var $input = $('#add-tmp-input'),
                        $txtArea = $('#tmp-body'),
                        settingsArr = self.userData.settings.templates[$(this).attr('data-id')],
                        findSameSubject = false;

                    if ($(this).attr('data-id') == 'ci' && self.textLength > 300) {
                        $txtArea.css('border-color', 'red');

                        self.sendMessageToContent({
                            action: 'showSystemNotification',
                            message: 'Max length: 300 symbols.'
                        }, null);

                        return;
                    }

                    if ($input.val() != '' && $txtArea.val() != '' && !$.isEmptyObject(self.userData.settings)) {
                        for (var i = 0; i < settingsArr.length; i++) { // Check for template with the same name
                            if (settingsArr[i].s == $input.val()) {
                                findSameSubject = true;
                            }
                        }

                        if (!findSameSubject) {
                            chrome.storage.local.remove('add');

                            settingsArr.push({
                                s: $input.val(),
                                b: $txtArea.val()
                            });

                            $input.val('');
                            $txtArea.val('');

                            self.saveChanges(function (resp) {
                                $('#tmp-wrap-create').hide();
                                $('#tmp-wrap-list').fadeIn();
                                $('#tmp-wrap-list').show();

                                console.log($('.tmp-wrap-create').length, $('.tmp-wrap-list').length);

                                self.activeTab = 'Templates';
                                self.getSettings();
                            });
                        } else { // There is template with the same name
                            $input.css('border-color', 'red');

                            self.sendMessageToContent({
                                action: 'showSystemNotification',
                                message: 'You already have template with the same subject.'
                            }, null);
                        }
                    }
                }
            });

            event.stopPropagation();
        }

        /* Add items to lists */
        function _addItems(type, prefix, $elem, data, itemIndex, valueIndex) {
            if (data.length) {
                for (var i = 0; i < data.length; i++) {
                    var $item = self.tagItemTmp.clone().show(),
                        index,
                        value;

                    // Check for item index. It can be loading all items from list or adding only one item
                    if (itemIndex) {
                        index = itemIndex;
                    } else {
                        index = i;
                    }

                    // Check for value index. It can be loading all items from list or adding only one
                    if (valueIndex) {
                        value = data[valueIndex];
                    } else {
                        value = data[i];
                    }

                    // Create unique id with prefix
                    $item.attr('id', prefix + '-' + index);

                    if (type == 'tmp') {
                        value = value.s;
                    }

                    $item.find('.item-label').text(value);

                    $elem.prepend($item);

                    var deleteElement = $elem.find('.delete-tag-item'),
                        arr = [];

                    // Define array of items
                    if (prefix == 'tag') {
                        arr = self.userData.settings.tags;

                    } else if (prefix == 'ci') {
                        arr = self.userData.settings.templates.ci;

                    } else if (prefix == 'co') {
                        arr = self.userData.settings.templates.co;

                    } else if (prefix == 'fum') {
                        arr = self.userData.settings.templates.fum;

                    } else if (prefix == 'm') {
                        arr = self.userData.settings.templates.m;
                    }

                    deleteElement.off('click');

                    deleteElement.on('click', function (e) { // Deleting element event
                        var itemValue = $(this).parent().find('.item-label').text(),
                            index;

                        for (var i = 0; i < arr.length; i++) {
                            var arrValue = arr[i];

                            if (type == 'tmp') {
                                arrValue = arrValue.s;
                            }

                            if (arrValue == itemValue) {
                                index = i;
                            }
                        }

                        arr.splice(index, 1);
                        self.saveChanges();

                        $(this).parent().remove();

                        e.preventDefault();
                    });

                    if (prefix != 'tag') {
                        var editElement = $elem.find('.item-label');

                        editElement.on('click', function (e) { // Editing element event
                            var $tmpCreate = $('#tmp-wrap-create'),
                                $saveBtn = $('.save-btn'),
                                $addTmpInput = $('#add-tmp-input'),
                                $tmpArea = $('#tmp-body'),
                                arrName, index;

                            arrName = $(this).parent().attr('id').split('-')[0];
                            index = parseInt($(this).parent().attr('id').split('-')[1]);

                            $addTmpInput.css('border-color', '#22a1c4');
                            $tmpArea.css('border-color', '#22a1c4');

                            var firstValue = self.userData.settings.templates[arrName][index].s;
                            $addTmpInput.val(self.userData.settings.templates[arrName][index].s);
                            $tmpArea.val(self.userData.settings.templates[arrName][index].b);

                            $('#tmp-wrap-list').hide();

                            $('.save-as-btn').hide();
                            $('.add-wrap-title').text('Edit template');
                            $saveBtn.show();

                            self.textLength = $tmpArea.val().length;
                            $('.txt-length').text('Text length: ' + self.textLength + ' symbols');

                            $tmpCreate.fadeIn();
                            $tmpCreate.show();

                            $saveBtn.off('click');
                            $saveBtn.on('click', function () { // Save template after editing
                                if (arrName == 'ci' && self.textLength > 300) {
                                    $('#tmp-body').css('border-color', 'red');

                                    self.sendMessageToContent({
                                        action: 'showSystemNotification',
                                        message: 'Max length: 300 symbols.'
                                    }, null);

                                    return;
                                }

                                if ($addTmpInput.val() != '' && $tmpArea.val() != '') {
                                    var settingsArr = self.userData.settings.templates[arrName],
                                        findSameSubject = false;

                                    for (var i = 0; i < settingsArr.length; i++) { // Check for template with the same name
                                        console.log(settingsArr[i].s, $addTmpInput.val(), firstValue)
                                        if (settingsArr[i].s == $addTmpInput.val() && $addTmpInput.val() != firstValue) {
                                            findSameSubject = true;
                                        }
                                    }

                                    if (!findSameSubject) {
                                        settingsArr[index].s = $addTmpInput.val();
                                        settingsArr[index].b = $tmpArea.val();

                                        chrome.storage.local.remove('add');

                                        self.saveChanges(function (resp) {
                                            $addTmpInput.val('');
                                            $tmpArea.val('');

                                            $('#tmp-wrap-create').hide();
                                            $('#tmp-wrap-list').fadeIn();
                                            $('#tmp-wrap-list').show();

                                            self.activeTab = 'Templates';
                                            self.getSettings();
                                        });

                                    } else { // There is template with the same name
                                        $addTmpInput.css('border-color', 'red');

                                        self.sendMessageToContent({
                                            action: 'showSystemNotification',
                                            message: 'You already have template with the same subject.'
                                        }, null);
                                    }

                                } else { // Subject or body is empty
                                    if ($('#add-tmp-input').val() == '') {
                                        $('#add-tmp-input').css('border-color', 'red');

                                        self.sendMessageToContent({
                                            action: 'showSystemNotification',
                                            message: 'Empty template subject.'
                                        }, null);
                                    }

                                    if ($('#tmp-body').val() == '') {
                                        $('#tmp-body').css('border-color', 'red');

                                        setTimeout(function () {
                                            self.sendMessageToContent({
                                                action: 'showSystemNotification',
                                                message: 'Empty template body.'
                                            }, null);
                                        }, 1000);
                                    }
                                }
                            });
                        });
                    }
                }
            }
        }

        var self = this;

        this.activeTab = 'Settings';
        this.src = '';
        this.name = '';
        this.userData = {};
        this.textLength = 0;
        this.showPopUp = false;
        this.buildList = false;
        this.refreshData = {};

        this.tagItemTmp = $('.content-item');

        this.payItem = $('.pay-item');


        /* Check information about user */
        this.checkUserInDB = function () {
            chrome.storage.local.remove('coupon');

            $('.loading').show();
            self.sendMessageToBg({action: 'session', login: false}, function (response) {
                console.log(response);

                if (response.err) {
                    $('.loading').hide();
                    self.serverErrState();

                } else if (!$.isEmptyObject(response)) {
                    console.log(response.expirationDate > new Date().getTime() / 1000, response.promoCode > new Date().getTime() / 1000)

                    if (response.status == 'In process') {
                        $('.loading').hide();
                        self.subscribeInProcessState(response); // Subscription is in process

                    } else if (response.expirationDate > new Date().getTime() / 1000 || response.promoCode > new Date().getTime() / 1000) {
                        self.tabInit(response);

                    } else {
                        console.log('HERE', response.expirationDate > new Date().getTime() / 1000, response.promoCode > new Date().getTime() / 1000)
                        $('.loading').hide();
                        self.subscribeState(response.status, response); // Not subscribed
                    }

                } else {
                    $('.loading').hide();
                    self.registerState(); // Not register
                }


            });
        };

        /* Server error state */
        this.serverErrState = function () {
            //chrome.storage.local.remove('state', function () {
            //self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, null);
            //});

            chrome.storage.local.remove('add');

            $('.system-info').css('height', '100px');
            $('.about-btn').hide();
            $('.server-err').show();
        };

        /* Subscribe state */
        this.subscribeState = function (status, userData) {
            chrome.storage.local.remove('state', function () {
                self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, null);
            });

            chrome.storage.local.remove('add');

            $('.unsubscribe-wrap').fadeIn(400, function () {
                $('.about-btn').show();
                $('.version').show();
            });

            $('.unsubscribe-wrap').show();
            $('.system-info').css('height', '130px');

            var url = '';

            if (userData.pictureUrl) {
                url = userData.pictureUrl;
            }

            $('.profile-img').attr('src', url);

            var name = '';

            if (userData.firstName) {
                name = userData.firstName + ' ' + userData.lastName;
            }

            $('.user-name').text(name);
            $('.current-status').text('Current status: ' + status);

            $('.sbscr-btn').on('click', function (e) {
                var popup = window.open('../html/stripe.html', "stripe_popup", "width=500px, height=750px ,left=0, top=0," +
                    "resizable=yes,scrollbars=no, titlebar=no,toolbar=no,menubar=no,location=yes,directories=no,status=yes");
                window.close();
            });

            /*setTimeout(function () {
             $('.about-btn').show();
             $('.version').show();
             }, 500);*/

            $('.about-btn').on('click', function () {
                $(this).hide();

                $('.unsubscribe-wrap').hide();
                $('.system-about').fadeIn();
                $('.system-info').css('height', '465px');
                $('.system-about').show();

                $('.about-back-btn').on('click', function () {
                    $('.about-btn').show();

                    $('.system-about').hide();
                    $('.system-info').css('height', '130px');
                    $('.unsubscribe-wrap').fadeIn();
                    $('.unsubscribe-wrap').show();
                });
            });

            $('.promo-btn').on('click', function () {
                $('.about-btn').hide();
                self.promoCodeForm();
            });

            $('.discount-btn').on('click', function () {
                $('.about-btn').hide();
                self.discountForm();
            });
        };

        /* Subscription's process state */
        this.subscribeInProcessState = function () {
            chrome.storage.local.remove('state', function () {
                self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, null);
            });

            chrome.storage.local.remove('add');

            $('.subscr-proc').fadeIn(400, function () {
                //$('.about-btn').show();
                $('.version').show();
            });

            $('.subscr-proc').show();
            $('.system-info').css('height', '65px');

            /*setTimeout(function () {
             $('.about-btn').show();
             $('.version').show();
             }, 500);*/
        };

        function _submitCouponCode(couponCodeValue) {
            if (couponCodeValue == '') {
                $('#discount-input').css('border-color', 'red');

                self.sendMessageToContent({action: 'showSystemNotification', message: 'Empty coupon-code.'}, null);

                return;
            }

            self.sendMessageToBg({action: 'couponCode', couponCode: couponCodeValue}, function (response) {
                if (response.err) {
                    return;

                } else if ($.isEmptyObject(response)) {
                    console.log('empty: ', response);

                    $('#discount-input').css('border-color', 'red');
                    self.sendMessageToContent({
                        action: 'showSystemNotification',
                        message: 'Sorry, but the coupon number is wrong. Please, try a different one.'
                    }, null);

                } else {
                    console.log('not empty: ', response);

                    self.sendMessageToContent({
                        action: 'showSuccessNotification',
                        message: 'Coupon number is correct! You were granted the discount!.'
                    }, null);

                    $('.discount-wrap').hide();

                    chrome.storage.local.set({coupon: response}, function () {
                        var popup = window.open('../html/stripe.html', "stripe_popup", "width=500px, height=750px ,left=0, top=0," +
                            "resizable=yes,scrollbars=no, titlebar=no,toolbar=no,menubar=no,location=yes,directories=no,status=yes");
                        window.close();
                    });
                }
            });
        }

        self.discountForm = function () {
            $('#discount-input').off('keyup change paste');
            $('.discount-enter-btn').off('click');
            $('.discount-back-btn').off('click');

            $('.unsubscribe-wrap').hide();
            $('.system-info').css('height', '160px');
            $('#discount-input').css('border-color', '#22a1c4');
            $('#discount-input').val('');

            $('.discount-wrap').fadeIn();
            $('.discount-wrap').show();

            var couponCodeValue = '';

            $('#discount-input').off('keyup change paste');
            $('#discount-input').on('keyup change paste', function (e) {
                couponCodeValue = $(this).val().trim();

                console.log(couponCodeValue);

                $(this).css('border-color', '#22a1c4');
            });

            $('.discount-back-btn').off('click');
            $('.discount-back-btn').on('click', function () {
                chrome.storage.local.remove('coupon');

                $('.about-btn').show();
                $('.discount-wrap').hide();

                self.subscribeState('Not subscribed', null);
            });

            $('#discount-input').off('keypress');
            $('#discount-input').on('keypress', function (e) {
                var key = e.which;
                if (key == 13)  // the enter key code
                {
                    _submitCouponCode(couponCodeValue);
                    return false;
                }
            });

            $('.discount-enter-btn').off('click');
            $('.discount-enter-btn').on('click', function () {
                _submitCouponCode(couponCodeValue);
            });
        };

        function _submitPromoCode(promoCodeValue) {
            if (promoCodeValue == '') {
                $('#promo-input').css('border-color', 'red');

                self.sendMessageToContent({action: 'showSystemNotification', message: 'Empty promo-code.'}, null);

                return;
            }

            self.sendMessageToBg({action: 'promoCode', promoCode: promoCodeValue}, function (response) {
                if (response.err) {
                    return;

                } else if (response == 0) {
                    $('#promo-input').css('border-color', 'red');
                    self.sendMessageToContent({
                        action: 'showSystemNotification',
                        message: 'Invalid promo-code.'
                    }, null);

                } else {
                    self.sendMessageToContent({
                        action: 'showSuccessNotification',
                        message: 'Promo-code activated.'
                    }, null);

                    window.close();
                    //$('.promo-wrap').hide();
                    //self.checkUserInDB();
                }
            });
        }

        /* Promo-code form*/
        this.promoCodeForm = function () {
            $('#promo-input').off('keyup change paste');
            $('.promo-enter-btn').off('click');
            $('.promo-back-btn').off('click');

            $('.unsubscribe-wrap').hide();
            $('.system-info').css('height', '160px');
            $('#promo-input').css('border-color', '#22a1c4');
            $('#promo-input').val('');

            $('.promo-wrap').fadeIn();
            $('.promo-wrap').show();

            var promoCodeValue = '';

            $('#promo-input').off('keyup change paste');
            $('#promo-input').on('keyup change paste', function (e) {
                promoCodeValue = $(this).val().trim();

                console.log(promoCodeValue);

                $(this).css('border-color', '#22a1c4');
            });

            $('.promo-back-btn').off('click');
            $('.promo-back-btn').on('click', function () {
                $('.about-btn').show();
                $('.promo-wrap').hide();

                self.subscribeState('Not subscribed', null);
            });

            $('#promo-input').off('keypress');
            $('#promo-input').on('keypress', function (e) {
                var key = e.which;
                if (key == 13)  // the enter key code
                {
                    _submitPromoCode(promoCodeValue);
                    return false;
                }
            });

            $('.promo-enter-btn').off('click');
            $('.promo-enter-btn').on('click', function () {
                _submitPromoCode(promoCodeValue);
            });
        };

        /* Register state */
        this.registerState = function () {
            chrome.storage.local.remove('state', function () {
                self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, null);
            });

            chrome.storage.local.remove('add');

            $('.login-wrap').fadeIn(400, function () {
                $('.about-btn').show();
                $('.version').show();
            });

            $('.login-wrap').show();
            $('.system-info').css('height', '120px');

            $('.login-btn').off('click');
            $('.login-btn').on('click', function () {
                chrome.storage.local.get('memberId', function (val) {
                    console.log(val);

                    //if ($.isEmptyObject(val)) {
                    //self.sendMessageToContent({action: 'reloadPage'}, null);
                    //}
                    //});

                    //self.sendMessageToBg({action: 'session', login: true}, function (response) {
                    //    console.log(response);

                    var session_cookie = '';

                    //if (response) {
                    //    session_cookie = response;
                    //}

                    self.sendMessageToBg({action: 'saveCurrentTab'}, function (resp) {
                        var state = _generateState(),
                            url = 'https://www.linkedin.com/oauth/v2/authorization?response_type=code&client_id='
                                + clientId +
                                '&redirect_uri=' +
                                redirectUri +
                                '&state=' +
                                state +
                                "&scope=r_liteprofile%20r_emailaddress",
                            popup = window.open(url, "yii_eauth_popup", "width=500px, height=650px ,left=0, top=0," +
                                "resizable=yes,scrollbars=no,toolbar=no,menubar=no,location=no,directories=no,status=yes");

                        popup.focus();

                        window.close();
                    });
                });



            });

            /*setTimeout(function () {
             $('.about-btn').show();
             $('.version').show();
             }, 500);*/

            $('.about-btn').on('click', function () {
                $(this).hide();

                $('.login-wrap').hide();
                $('.system-about').fadeIn();
                $('.system-info').css('height', '465px');
                $('.system-about').show();

                $('.about-back-btn').on('click', function () {
                    $('.about-btn').show();

                    $('.system-about').hide();
                    $('.system-info').css('height', '120px');
                    $('.login-wrap').fadeIn();
                    $('.login-wrap').show();
                });
            });
        };

        /* Get user info and render it */
        this.showPopUpInfo = function (response) {
            function _buildPopUp(cb) {
                $('.loading').hide();
                $('.multitab-section').show();

                chrome.storage.local.get('add', function (val) {
                    console.log(cb, val);

                    if (cb && !$.isEmptyObject(val) && (val.add.s != '' || val.add.b != '')) {
                        $(".multitab-widget-content-widget-id").hide();
                        $("#tab2").addClass("multitab-widget-current").show();
                        $("#multicolumn-widget-id2").show();

                        self.activeTab = 'Templates';

                        $('.elements').show();
                        $('#tmp-wrap-list').hide();
                        $('#tmp-wrap-create').show();

                        $('#add-tmp-input').val(val.add.s);
                        $('#tmp-body').val(val.add.b);
                        $('.txt-length').text('Text length: ' + $('#tmp-body').val().length + ' symbols');

                        console.log($('#tmp-body'))
                        self.textLength = $('#tmp-body').val().length;

                    } else {
                        $(".multitab-widget-content-widget-id").hide();
                        $("ul.multitab-widget-content-tabs-id li:first a").addClass("multitab-widget-current").show();
                        $(".multitab-widget-content-widget-id:first").show();
                    }

                    $('.about-btn').show();
                    $('.version').show();
                });

                self.tabEvents();
                self.popupEvents();
            }

            if (!response) {
                self.getSettings(function (resp) {
                    _buildPopUp(true);

                    self.userData = resp;
                    self.renderPopup(resp);
                });

            } else {
                _buildPopUp(true);

                self.userData = response;
                self.renderPopup(response);
            }

            console.log(self.userData)
        };

        this.checkForRefreshProcessing = function (data) {
            //var processingInterval = setInterval(function () {
            console.log('processingStatus2');
            self.sendMessageToBg({action: 'processingStatus'}, function (resp) {
                //console.log(resp.showNotification[0]);

                if (resp.showNotification[0] || resp.showErrorNotification) {
                    self.sendMessageToContent({
                        action: 'showProcessingNotification',
                        data: resp
                    }, null);
                }

                if (resp.progressInfo.action == 'refresh' && !resp.refreshArr.length) {
                    self.refreshSearchingState(resp);
                    self.buildList = false;

                    setTimeout(function () {
                        self.checkForRefreshProcessing();
                    }, 1000);

                } else if (resp.progressInfo.action == 'refresh' && resp.refreshArr.length) {
                    //console.log('LIST OF CONNECTS: ', resp.refreshArr);

                    if (!self.buildList) {
                        self.refreshListState(resp, data);
                        self.buildList = true;
                    }

                } else {
                    chrome.storage.local.remove('state', function () {
                        $('.fu-wrap').hide();
                        self.buildList = false;

                        if (!self.showPopUp) {
                            console.log('checkForRefreshProcessing');

                            self.showPopUpInfo(null);
                            self.showPopUp = true;
                        }
                    });

                    //clearInterval(processingInterval);
                }
            });
            //}, 1000);
        };

        /* Show first tab at start */
        this.tabInit = function (response) {
            chrome.storage.local.get('state', function (data) {
                console.log('STATE: ', data);

                if (!$.isEmptyObject(data)) {
                    self.checkForRefreshProcessing(data);

                } else {
                    self.showPopUp = true;
                    console.log('tabInit');

                    self.showPopUpInfo(response);
                }
            });
        };

        /* Check true location of page */
        this.checkLocation = function () {
            //self.sendMessageToContent({action: 'checkLocation'}, function (userData) {
            //    //self.src = userData.src;
            //    //self.name = userData.name;
            //
            self.checkUserInDB();
            //});
        };

        /* Get user settings */
        this.getSettings = function (callback) {
            callback = callback || function () {
            };

            self.sendMessageToBg({action: 'getSettings'}, function (userData) {
                console.log('UD: ', userData);

                if (userData.err || $.isEmptyObject(userData)) {
                    $('.multitab-section').hide();
                    self.serverErrState();

                    return;

                } else if (userData.expirationDate < new Date().getTime() / 1000 && userData.promoCode < new Date().getTime() / 1000) {
                    console.log('HERE2')
                    $('.multitab-section').hide();
                    self.subscribeState('Not subscribed', null);

                } else {
                    callback(true);
                }

                self.userData = userData;
                self.renderPopup(userData);
            });
        };

        /* Listeners for tab events */
        this.tabEvents = function () {
            $("ul.multitab-widget-content-tabs-id li a").off('click');
            $("ul.multitab-widget-content-tabs-id li a").on('click', function () {
                $('.about-btn').hide();
                $('.version').hide();

                chrome.storage.local.remove('add');

                self.showPopUp = true;

                $("ul.multitab-widget-content-tabs-id li a").removeClass("multitab-widget-current a");
                $(this).addClass("multitab-widget-current");
                $(".multitab-widget-content-widget-id").hide();

                var activeElement = $(this).attr("href");
                $(activeElement).fadeIn(400, function () {
                    $('.about-btn').show();
                    $('.version').show();
                });

                self.activeTab = $(this).text();
                self.getSettings();

                return false;
            });
        };

        /* Render popup */
        this.renderPopup = function (response) {
            if (self.userData.settings) {
                $('.err-msg').hide();
                $('.server-err').hide();
                $('.multitab-widget').show();
                $('.info-wrap').show();

                var url = '';

                if (response.pictureUrl) {
                    url = response.pictureUrl;
                }

                $('.profile-img').attr('src', url);

                var name = '';

                if (response.firstName) {
                    name = response.firstName + ' ' + response.lastName;
                }

                $('.user-name').text(name);
                $('.content').html('');
                $('.elements').show();
                $('.my-payments-wrap').hide();
                $('.about-wrap').hide();

                if (self.activeTab == 'Settings') {
                    self.setMainSettings();

                } else {
                    var $tmp_wrap_create = $('#tmp-wrap-create');
                    $('.add-wrap-title').text('Create new template');
                    $('#tmp-body', $tmp_wrap_create).css('border-color', '#22a1c4');
                    $('#add-tmp-input', $tmp_wrap_create).css('border-color', '#22a1c4');
                    $tmp_wrap_create.hide();
                    $('#tmp-wrap-list').show();

                    self.addTemplatesList();
                }
            }
        };

        this.refreshSearchingState = function (resp) {
            chrome.storage.local.set({state: {action: 'searching'}}, function () {
                $('.loading').hide();
                $('.multitab-section').hide();
                $('.about-btn').hide();
                $('.info-png').hide();
                $('.items-wrap').html('');
                $('.items-wrap').hide();
                $('.fu-input-wrap').hide();
                $('.fu-send').hide();
                $('.fu-wrap').show();
                $('.fu-searching-info').show();
                $('.fu-input').attr('disabled', true);
                $('.fu-input').val('');
                $('.fu-area').attr('disabled', true);
                $('.fu-area').val('');
                $('.fu-input').css('border-color', 'rgb(156, 154, 154)');
                $('.fu-area').css('border-color', 'rgb(156, 154, 154)');
                $('.version').show();

                self.showPopUp = false;

                $('.fu-cancel').off('click');
                $('.fu-cancel').on('click', function () {
                    self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, function (cb) {
                        self.sendMessageToContent({action: 'showProcessingNotification', data: resp}, null);
                    });

                    chrome.storage.local.remove('state', function () {
                        $('.fu-wrap').hide();
                        $('.loading').show();

                        if (!self.showPopUp) {
                            console.log('refreshSearchingState');

                            self.showPopUpInfo(null);
                            self.showPopUp = true;
                        }
                    });
                });
            });
        };

        this.refreshListState = function (resp, storageData) {
            console.log('DATA: ', storageData);

            if (storageData) {
                if (storageData.state.data) {
                    self.refreshData = storageData.state.data;
                    console.log('THIS')

                } else {
                    self.refreshData = resp.refreshArr;
                    console.log('THIS 2')
                }

            } else {
                chrome.storage.local.set({state: {action: 'list'}}, function () {
                });

                self.refreshData = resp.refreshArr;
            }

            console.log('REFRESH DATA: ', self.refreshData);

            function _listInit() {
                $('.loading').hide();
                $('.multitab-section').hide();
                $('.fu-wrap').show();
                $('.fu-searching-info').hide();
                $('.info-png').show();
                $('.items-wrap').html('');
                $('.items-wrap').show();
                $('.fu-input').attr('placeholder', '');
                $('.fu-area').attr('placeholder', '');
                $('.fu-input-wrap').show();
                $('.about-btn').hide();
                $('.version').show();

                self.buildListOfConnects(resp);

                $('.fu-send').show();

                self.showPopUp = false;
            }

            _listInit();
        };

        this.buildListOfConnects = function (resp) {
            var tmp = $('.fu-item'),
                $asterisk = $('.asterisk');

            console.log('DATA BEFORE BUILD: ', self.refreshData);

            for (var i = 0; i < self.refreshData.length; i++) {
                var $item = tmp.clone().show();

                $item.find('input').attr('id', self.refreshData[i].memberData.id);
                $item.find('input').attr('name', self.refreshData[i].memberData.id);
                $item.find('label').attr('for', self.refreshData[i].memberData.id);
                $item.find('.item-value').attr('title', self.refreshData[i].memberData.name);
                $item.find('.item-value').text(self.refreshData[i].memberData.name);
                $item.find('a').attr('href', self.refreshData[i].memberData.profileUrl);

                if (self.refreshData[i].fum == 'false') {
                    self.refreshData[i].checked = false;
                    $item.find('.item-value').after($asterisk.clone().css('display', 'inline-block'));
                    $item.find('.input-blocker').show();

                } else {
                    if (self.refreshData[i].fum.s != '' && self.refreshData[i].fum.b != '') {
                        console.log('CHECK CHECKED: ', self.refreshData[i].memberData.name, self.refreshData[i].checked,
                            typeof self.refreshData[i].checked);

                        if (typeof self.refreshData[i].checked == 'undefined') {
                            self.refreshData[i].checked = true;
                            $item.find('input').prop('checked', true);

                        } else {
                            if (self.refreshData[i].checked) {
                                $item.find('input').prop('checked', true);
                            }
                        }

                    } else {
                        console.log('CHECK CHECKED: ', self.refreshData[i].memberData.name, self.refreshData[i].checked);

                        self.refreshData[i].checked = false;
                        $item.find('.input-blocker').show();
                    }
                }

                $('.items-wrap').append($item);
            }

            self.connectsListEvents(resp);
        };

        this.connectsListEvents = function (response) {
            var activeId, newSubject = '', newBody = '';

            $('.fu-item-label').off('click');
            $('.fu-item-label').on('click', function (e) {
                var checked = false,
                    id = $(this).attr('for');

                console.log('checked: ', $(this).parent().find('input').prop('checked'));

                if ($(this).parent().find('input').prop('checked')) {
                    console.log('REMOVE');
                    checked = false;

                } else {
                    console.log('ADD');
                    checked = true;
                }

                for (var i = 0; i < self.refreshData.length; i++) {
                    if (self.refreshData[i].memberData.id == id) {
                        if (checked) {
                            self.refreshData[i].checked = true;

                            chrome.storage.local.set({
                                state: {
                                    action: 'list',
                                    data: self.refreshData
                                }
                            }, function (resp) {
                                console.log('SAVED: ', self.refreshData);
                            });

                        } else {
                            self.refreshData[i].checked = false;

                            chrome.storage.local.set({
                                state: {
                                    action: 'list',
                                    data: self.refreshData
                                }
                            }, function (resp) {
                                console.log('SAVED: ', self.refreshData);
                            });
                        }

                        chrome.storage.local.get('state', function (resp) {
                            console.log('CHECK STORAGE: ', resp);
                        });
                    }
                }

                console.log('NEW DATA: ', self.refreshData);
            });

            $('.item-value').off('click');
            $('.item-value').on('click', function () {
                var id = parseInt($(this).parent().find('input').attr('id')),
                    found = false;

                activeId = id;

                $('.fu-input').removeAttr('disabled');
                $('.fu-area').removeAttr('disabled');
                $('.fu-input').css('border-color', '#22a1c4');
                $('.fu-area').css('border-color', '#22a1c4');

                for (var i = 0; i < self.refreshData.length; i++) {
                    if (self.refreshData[i].memberData.id == id) {
                        if (self.refreshData[i].fum != 'false') {
                            found = self.refreshData[i];

                            if (self.refreshData[i].fum.s == '') {
                                $('.fu-input').attr('placeholder', 'No subject attached for ' + self.refreshData[i].memberData.name);
                            }

                            if (self.refreshData[i].fum.b == '') {
                                $('.fu-area').attr('placeholder', 'No message attached for ' + self.refreshData[i].memberData.name);
                            }

                        } else {
                            $('.fu-input').attr('placeholder', 'No subject attached for ' + self.refreshData[i].memberData.name);
                            $('.fu-area').attr('placeholder', 'No message attached for ' + self.refreshData[i].memberData.name);
                        }
                    }
                }

                console.log('FOUND: ', found)

                if (found) {
                    $('.fu-input').val(found.fum.s);
                    $('.fu-area').val(found.fum.b);

                } else {
                    $('.fu-input').val('');
                    $('.fu-area').val('');
                }
            });

            $('.fu-input').off('keyup paste change');
            $('.fu-input').on('keyup paste change', function () {
                console.log(activeId);

                $(this).css('border-color', '#22a1c4');

                if (activeId) {
                    newSubject = $(this).val();

                    for (var i = 0; i < self.refreshData.length; i++) {
                        if (activeId == self.refreshData[i].memberData.id) {
                            if (self.refreshData[i].fum != 'false') {
                                self.refreshData[i].fum.s = newSubject;

                            } else {
                                var obj = {s: newSubject, b: newBody};

                                self.refreshData[i].fum = obj;
                            }

                            if (self.refreshData[i].fum.s != '' && self.refreshData[i].fum.b != '') {
                                $('#' + activeId).parent().find('.input-blocker').hide();
                                $('#' + activeId).parent().find('input').prop('checked', true);

                                self.refreshData[i].checked = true;

                                console.log('INPUT TRUE: ', self.refreshData[i].checked)

                            } else {
                                $('#' + activeId).parent().find('.input-blocker').show();
                                $('#' + activeId).parent().find('input').attr('checked', false);

                                self.refreshData[i].checked = false;

                                console.log('INPUT FALSE: ', self.refreshData[i].checked)
                            }

                            chrome.storage.local.set({
                                state: {
                                    action: 'list',
                                    data: self.refreshData
                                }
                            }, function (resp) {
                                console.log('SAVED: ', self.refreshData);
                            });

                            newSubject = '';

                            console.log(self.refreshData[i].fum);
                        }
                    }
                }
            });

            $('.fu-area').off('keyup paste change');
            $('.fu-area').on('keyup paste change', function () {
                console.log(activeId);

                $(this).css('border-color', '#22a1c4');

                if (activeId) {
                    newBody = $(this).val();

                    for (var i = 0; i < self.refreshData.length; i++) {
                        if (activeId == self.refreshData[i].memberData.id) {
                            if (self.refreshData[i].fum != 'false') {
                                self.refreshData[i].fum.b = newBody;

                                chrome.storage.local.set({
                                    state: {
                                        action: 'list',
                                        data: self.refreshData
                                    }
                                }, function (resp) {
                                    console.log('SAVED: ', self.refreshData);
                                });

                            } else {
                                var obj = {s: newSubject, b: newBody};

                                self.refreshData[i].fum = obj;

                                chrome.storage.local.set({
                                    state: {
                                        action: 'list',
                                        data: self.refreshData
                                    }
                                }, function (resp) {
                                    console.log('SAVED: ', self.refreshData);
                                });
                            }

                            if (self.refreshData[i].fum.s != '' && self.refreshData[i].fum.b != '') {
                                $('#' + activeId).parent().find('.input-blocker').hide();
                                $('#' + activeId).parent().find('input').prop('checked', true);

                                self.refreshData[i].checked = true;

                            } else {
                                $('#' + activeId).parent().find('.input-blocker').show();
                                $('#' + activeId).parent().find('input').attr('checked', false);

                                self.refreshData[i].checked = false;
                            }

                            newBody = '';

                            console.log(self.refreshData[i].fum);
                        }
                    }
                }
            });

            $('.input-blocker').off('click');
            $('.input-blocker').on('click', function () {
                var id = $(this).parent().find('input').attr('id');

                activeId = id;

                console.log('id: ', id);

                $('.fu-input').removeAttr('disabled');
                $('.fu-area').removeAttr('disabled');
                $('.fu-input').css('border-color', '#22a1c4');
                $('.fu-area').css('border-color', '#22a1c4');

                for (var i = 0; i < self.refreshData.length; i++) {
                    if (id == self.refreshData[i].memberData.id) {
                        if (self.refreshData[i].fum != 'false') {
                            $('.fu-input').val(self.refreshData[i].fum.s);
                            $('.fu-area').val(self.refreshData[i].fum.b);

                            if (self.refreshData[i].fum.s == '') {
                                console.log('Empty subject');

                                $('.fu-input').attr('placeholder', 'No subject attached for ' + self.refreshData[i].memberData.name);

                                self.sendMessageToContent({
                                    action: 'showSystemNotification',
                                    message: 'Empty message subject.'
                                }, null);

                                $('.fu-input').css('border-color', 'red');
                            }

                            if (self.refreshData[i].fum.b == '') {
                                console.log('Empty body');

                                $('.fu-area').attr('placeholder', 'No message attached for ' + self.refreshData[i].memberData.name);

                                self.sendMessageToContent({
                                    action: 'showSystemNotification',
                                    message: 'Empty message body.'
                                }, null);

                                $('.fu-area').css('border-color', 'red');
                            }

                        } else {
                            console.log('Both empty');

                            self.sendMessageToContent({
                                action: 'showSystemNotification',
                                message: 'Empty message subject.'
                            }, null);

                            setTimeout(function () {
                                self.sendMessageToContent({
                                    action: 'showSystemNotification',
                                    message: 'Empty message body.'
                                }, null);
                            }, 500);

                            $('.fu-input').css('border-color', 'red');
                            $('.fu-area').css('border-color', 'red');

                            $('.fu-input').val('');
                            $('.fu-area').val('');

                            $('.fu-input').attr('placeholder', 'No subject attached for ' + self.refreshData[i].memberData.name);
                            $('.fu-area').attr('placeholder', 'No message attached for ' + self.refreshData[i].memberData.name);
                        }
                    }
                }
            });

            $('.fu-cancel').off('click');
            $('.fu-cancel').on('click', function () {
                self.sendMessageToBg({action: 'stop_progress', type: 'refresh'}, function (cb) {
                    self.sendMessageToContent({action: 'showProcessingNotification', data: response}, null);
                });

                chrome.storage.local.remove('state', function () {
                    $('.fu-wrap').hide();
                    $('.loading').show();

                    if (!self.showPopUp) {
                        console.log('connectsListEvents');

                        self.showPopUpInfo(null);
                        self.showPopUp = true;
                    }
                });
            });

            $('.fu-send').off('click');
            $('.fu-send').on('click', function () {
                console.log('SEND CLICK');

                self.sendMessageToBg({action: 'sendFollowUps', data: self.refreshData}, null);

                chrome.storage.local.remove('state', function () {
                    window.close();
                });
            });
        };

        /* Check for processing */
        this.checkProcessing = function () {
            //var processingInterval = setInterval(function () {
            console.log('processingStatus3');
            self.sendMessageToBg({action: 'processingStatus'}, function (resp) {
                //console.log('process false', resp.progressInfo.action, resp.progressInfo.counter, resp.refreshArr);
                console.log(resp.showNotification[0]);

                if (resp.showNotification[0] || resp.showErrorNotification) {
                    self.sendMessageToContent({
                        action: 'showProcessingNotification',
                        data: resp
                    }, null);
                }

                if (resp.processing) {
                    //console.log('process true');
                    $('.refresh-btn').hide();
                    $('.refresh-process-btn').show();

                    if (resp.progressInfo.action == 'refresh' && !resp.refreshArr.length && resp.progressInfo.counter == 'Searching...') {
                        self.refreshSearchingState(resp);
                        self.buildList = false;
                    }

                    setTimeout(function () {
                        self.checkProcessing();
                    }, 1000);

                } else {
                    console.log('process false', resp.progressInfo.action, resp.progressInfo.counter, resp.refreshArr);

                    if (resp.progressInfo.action == 'refresh' && resp.refreshArr.length && resp.progressInfo.counter == 'Searching...') {
                        //console.log('refresh list');

                        if (!self.buildList) {
                            self.refreshListState(resp);
                            self.buildList = true;
                        }

                    } else {
                        //console.log('refresh clear');

                        $('.refresh-process-btn').hide();
                        $('.refresh-btn').show();

                        chrome.storage.local.remove('state', function () {
                            $('.fu-wrap').hide();
                            self.buildList = false;

                            //console.log('POPUP: ', self.showPopUp)
                            if (!self.showPopUp) {
                                //console.log('checkProcessing')
                                self.showPopUpInfo(null);
                                self.showPopUp = true;
                            }
                        });
                    }
                }
            });
            //}, 1000);
        };

        /* Set main settings */
        this.setMainSettings = function () {
            var $tmp_wrap_create = $('#tmp-wrap-create');
            $('.add-wrap-title').text('Create new template');
            $('#tmp-body', $tmp_wrap_create).css('border-color', '#22a1c4');
            $('#add-tmp-input', $tmp_wrap_create).css('border-color', '#22a1c4');
            $tmp_wrap_create.hide();

            if (!$.isEmptyObject(self.userData.settings)) {
                $('.current-status').text('Current status: ' + self.userData.status);

                var d = self.userData.expirationDate;

                if (self.userData.promoCode > 0 && d == 0) {
                    d = self.userData.promoCode;

                } else {
                    $('.current-status').hover(function () {
                        $(this).css({
                            'cursor': 'pointer',
                            'color': '#22a1c4'
                        });
                    }, function () {
                        $(this).css({
                            'color': '#000000'
                        });
                    });

                    $('.current-status').on('click', function () {
                        console.log('DATA: ', self.userData);
                        self.myPayments();
                    });
                }

                var date = new Date(d * 1000),
                    day = date.getDate(),
                    month = date.getMonth() + 1;

                if (day < 10) {
                    day = '0' + day;
                }

                if (month < 10) {
                    month = '0' + month;
                }

                date = month + '/' + day + '/' + date.getFullYear();
                $('.account-valid').text('Account valid till: ' + date);

                $('#cancel-connection').prop('checked', self.userData.settings.cancelConnection);
                $('#number-of-select').text(self.userData.settings.users);

                self.checkProcessing();

                _addItems('tag', 'tag', $('#tag-wrap'), self.userData.settings.tags, null);

                $('#add-tag-input').val('');
                $('#add-tag-input').css('border-color', '#22a1c4');
            }
        };

        /* Add templates lists */
        this.addTemplatesList = function () {
            if (!$.isEmptyObject(self.userData.settings)) {
                _addItems('tmp', 'ci', $('#ci-wrap'), self.userData.settings.templates.ci, null, null);
                _addItems('tmp', 'co', $('#co-wrap'), self.userData.settings.templates.co, null, null);
                _addItems('tmp', 'fum', $('#fum-wrap'), self.userData.settings.templates.fum, null, null);
                _addItems('tmp', 'm', $('#m-wrap'), self.userData.settings.templates.m, null, null);
            }

            /*setTimeout(function () {
             $('.about-btn').show();
             $('.version').show();
             }, 500);*/
        };

        /* Popup events listener */
        this.popupEvents = function () {
            $('.about-btn').off('click');
            $('.about-btn').on('click', function () {
                $(this).hide();

                $('.elements').hide();
                $('.about-wrap').fadeIn();
                $('.about-wrap').show();

                $('.about-back-btn').off('click');
                $('.about-back-btn').on('click', function () {
                    $('.about-btn').show();

                    $('.about-wrap').hide();
                    $('.elements').fadeIn();
                    $('.elements').show();
                });
            });

            $('#number-of-select').off('click');
            $('#number-of-select').on('click', function () {
                _showHideList($(this), $('#nof-list'), $('.nof-list-item'), 'changeSelectValue');
            });

            $('#cancel-checkbox').off('click');
            $('#cancel-checkbox').on('click', function (e) {
                if (e.target.localName == 'input') {
                    self.userData.settings.cancelConnection = e.target.checked;
                    self.saveChanges();
                    self.sendMessageToBg({action: 'changeCancelConnectsStatus', checked: e.target.checked}, null);
                }
            });

            $('.refresh-btn').off('click');
            $('.refresh-btn').on('click', function () {
                $(this).hide();
                $('.refresh-process-btn').show();

                self.sendMessageToBg({action: 'session', login: false}, function (user) {
                    if (user.err) {
                        alertify.notify('Connection error. Please try again in a few minutes.', 'error', 5);

                        return;

                    } else if (!$.isEmptyObject(user)) {
                        // Check for user subscription or expiration date
                        if (user.expirationDate > new Date().getTime() / 1000 || user.promoCode > new Date().getTime() / 1000) {
                            $('.refresh-btn').hide();
                            $('.refresh-process-btn').show();

                            console.log('this');
                            self.sendMessageToContent({action: 'refresh'}, null);

                            setTimeout(function () {
                                self.checkProcessing();
                            }, 1000);

                        } else {
                            if (user.expirationDate < new Date().getTime() / 1000 && user.expirationDate != 0) {
                                self.sendMessageToContent({
                                    action: 'showSystemNotification',
                                    message: 'Your subscription has expired.'
                                }, function (resp) {
                                    if (resp) {
                                        window.close();
                                    }
                                });

                            } else if (user.promoCode < new Date().getTime() / 1000 && user.promoCode != 0) {
                                self.sendMessageToContent({
                                    action: 'showSystemNotification',
                                    message: 'Your promo code has expired.'
                                }, function (resp) {
                                    if (resp) {
                                        window.close();
                                    }
                                });
                            }
                        }

                    } else {
                        window.close();
                    }
                });
            });

            $('#add-tag-input').off('keyup change paste');
            $('#add-tag-input').on('keyup change paste', function () {
                var el = $(this);

                //setTimeout(function () {
                el.css('border-color', '#22a1c4');
                //}, 100);
            });

            $('.save-tag').off('click');
            $('.save-tag').on('click', function () {
                var $tagInput = $('#add-tag-input'),
                    findSameTag = false;

                if ($tagInput.val() != '' && !$.isEmptyObject(self.userData.settings)) {
                    for (var i = 0; i < self.userData.settings.tags.length; i++) {
                        if ($tagInput.val() == self.userData.settings.tags[i]) {
                            findSameTag = true;
                        }
                    }

                    if (!findSameTag) {
                        _addItems('tag', 'tag', $('#tag-wrap'), [$tagInput.val()], self.userData.settings.tags.length, 0);

                        self.userData.settings.tags.push($tagInput.val());
                        self.saveChanges();

                        $tagInput.val('');
                    } else {
                        $tagInput.css('border-color', 'red');

                        self.sendMessageToContent({
                            action: 'showSystemNotification',
                            message: 'You already have tag with the same subject.'
                        }, null);
                    }
                } else {
                    $('#add-tag-input').css('border-color', 'red');

                    self.sendMessageToContent({
                        action: 'showSystemNotification',
                        message: 'Empty tag name.'
                    }, null);
                }
            });

            var $tmpCreate = $('#tmp-wrap-create'),
                $tmpList = $('#tmp-wrap-list'),
                $addTmpInput = $('#add-tmp-input'),
                $addTmpArea = $('#tmp-body');

            $('.add-btn-wrap').off('click');
            $('.add-btn-wrap').on('click', function () {
                chrome.storage.local.set({add: {s: '', b: ''}}, function (val) {
                    self.textLength = 0;

                    var $tmp_wrap_create = $('#tmp-wrap-create');
                    $('.add-wrap-title').text('Create new template');
                    $('#tmp-body', $tmp_wrap_create).css('border-color', '#22a1c4');
                    $('#add-tmp-input', $tmp_wrap_create).css('border-color', '#22a1c4');

                    $('.txt-length').text('Text length: ' + self.textLength + ' symbols');
                    $('.save-btn').hide();
                    $('.save-as-btn').show();

                    $('#tmp-wrap-list').hide();

                    $addTmpInput.val('');
                    $addTmpArea.val('');

                    $tmpCreate.fadeIn();
                    $tmpCreate.show();
                });
            });

            var tmpSubject = '', tmpBody = '';

            $addTmpInput.off('keyup change paste');
            $addTmpInput.on('keyup change paste', function () {
                var el = $(this);

                el.css('border-color', '#22a1c4');

                chrome.storage.local.get('add', function (v) {
                    console.log(v);

                    if (!$.isEmptyObject(v)) {
                        tmpSubject = el.val();
                        console.log(tmpSubject);

                        v.add.s = tmpSubject;

                        chrome.storage.local.set({add: v.add});
                    }
                });
            });

            $addTmpArea.off('keyup change paste');
            $addTmpArea.on('keyup change paste', function () {
                var el = $(this);

                el.css('border-color', '#22a1c4');

                setTimeout(function () {
                    self.textLength = el.val().length;
                    $('.txt-length').text('Text length: ' + self.textLength + ' symbols');

                    chrome.storage.local.get('add', function (v) {
                        console.log(v);

                        if (!$.isEmptyObject(v)) {
                            tmpBody = el.val();
                            console.log(tmpBody);

                            v.add.b = tmpBody;

                            chrome.storage.local.set({add: v.add});
                        }
                    });
                }, 100);

            });

            $('.save-as-btn').off('click');
            $('.save-as-btn').on('click', function () {
                _showHideList($(this), $('#save-as-list'), $('.save-as-list-item'), 'saveAs');
            });

            $('.cancel-btn').off('click');
            $('.cancel-btn').on('click', function () {
                chrome.storage.local.remove('add');

                self.getSettings();

                $('#tmp-wrap-create').hide();

                $('#tmp-body').css('border-color', '#22a1c4');

                $tmpList.fadeIn();
                $tmpList.show();
            });
        };

        /* My payments page */
        this.myPayments = function () {
            self.sendMessageToBg({action: 'getPayments'}, function (data) {
                if (!$.isEmptyObject(data)) {
                    $('.elements').hide();
                    $('.my-payments-wrap').fadeIn();
                    $('.my-payments-wrap').show();

                    $('.payments-block').html('');

                    var payments = data.payments;

                    if (payments.length) {
                        for (var i = 0; i < payments.length; i++) {
                            var $payItem = self.payItem.clone().show(),
                                date = new Date(payments[i].date * 1000),
                                day = date.getDate(),
                                month = date.getMonth() + 1,
                                status,
                                cost = '$' + (payments[i].total / 100).toFixed(2);

                            if (day < 10) {
                                day = '0' + day;
                            }

                            if (month < 10) {
                                month = '0' + month;
                            }

                            date = month + '/' + day + '/' + date.getFullYear();

                            if (payments[i].paid) {
                                status = 'Paid';
                            }

                            $payItem.find('.item-date').text(date);
                            $payItem.find('.item-status').text(status);
                            $payItem.find('.item-cost').text(cost);

                            $('.payments-block').append($payItem);
                        }

                        $('.pay-back-btn').on('click', function () {
                            $('.my-payments-wrap').hide();
                            $('.elements').show();
                        });

                        if (data.status != 'canceled') {
                            $('.unsubscr-btn').show();

                            var $payItem = self.payItem.clone().show(),
                                nextPaymentDate = new Date(payments[payments.length - 1].date * 1000 + 365 * 24 * 60 * 60 * 1000),
                                nextPaymentDay = nextPaymentDate.getDate(),
                                nextPaymentMonth = nextPaymentDate.getMonth() + 1;

                            if (nextPaymentDay < 10) {
                                nextPaymentDay = '0' + nextPaymentDay;
                            }

                            if (nextPaymentMonth < 10) {
                                nextPaymentMonth = '0' + nextPaymentMonth;
                                2
                            }

                            nextPaymentDate = nextPaymentMonth + '/' + nextPaymentDay + '/' + nextPaymentDate.getFullYear();

                            $payItem.find('.item-date').text(nextPaymentDate);
                            $payItem.find('.item-status').text('Planned');
                            $payItem.find('.item-cost').text('$' + (payments[0].total / 100).toFixed(2));

                            $('.payments-block').append($payItem);

                            $('.unsubscr-btn').on('click', function () {
                                $('.dialog-tmp').show();
                                $('.dialog-title').show();
                                $('.dialog-buttons-wrap').show();

                                $('.no-btn').on('click', function () {
                                    $('.dialog-tmp').hide();
                                    $('.dialog-title').hide();
                                    $('.dialog-buttons-wrap').hide();
                                });

                                $('.yes-btn').on('click', function () {
                                    self.sendMessageToBg({action: 'cancelSubscription'}, null);
                                    window.close();
                                });
                            });
                        }
                    }
                }
            });
        };

        /* Save changes for settings */
        this.saveChanges = function (callback) {
            callback = callback || function () {
            };

            self.sendMessageToBg({action: 'saveSettings', settings: self.userData.settings}, function (cb) {
                if (cb) {
                    if (callback) {
                        callback(true);
                    }

                    self.sendMessageToContent({action: 'saved'});
                }
            });
        };

        /* Send messages to content script */
        this.sendMessageToContent = function (options, callback) {
            callback = callback || function () {
            };

            chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
                chrome.tabs.sendMessage(tabs[0].id, options, function (response) {
                    console.log('RESPONSE: ', response);

                    if (options.action == "mailto_event") {
                        callback(response);
                    } else if (response) {
                        if (response.resp) {
                            $('.err-msg').hide();

                            callback({src: response.info.src, name: response.info.name});

                        } else if (response.msgResp) {
                            callback(true);
                        }

                    } else {
                        if (response) {
                            $('.multitab-widget').hide();
                            $('.err-msg').show();
                            $('.about-btn').hide();
                            $('.system-info').css('height', '85px');

                            self.checkLocation();
                        }
                    }
                });
            });
        };

        /* Send message to background script */
        this.sendMessageToBg = function (options, callback) {
            callback = callback || function () {
            };

            chrome.runtime.sendMessage(options, function (response) {
                //console.log(response);

                //if ($.isEmptyObject(response)) { TODO: check if server or mongo error
                //self.sendMessageToContent({action: 'serverErr'});
                //}

                callback(response);
            });
        };

        this.run = function () {
            //self.checkLocation();

            self.checkUserInDB();

            $('.connect-btn').on('click', function () {
                self.sendMessageToBg({action: 'session', login: false}, function (user) {
                    if (user.err) {
                        alertify.notify('Connection error. Please try again in a few minutes.', 'error', 5);

                        return;

                    } else if (!$.isEmptyObject(user)) {
                        // Check for user subscription or expiration date
                        if (user.expirationDate < new Date().getTime() / 1000 && user.expirationDate != 0) {
                            self.sendMessageToContent({
                                action: 'showSystemNotification',
                                message: 'Your subscription has expired.'
                            }, function (resp) {
                                if (resp) {
                                    window.close();
                                }
                            });

                        } else if (user.promoCode < new Date().getTime() / 1000 && user.promoCode != 0) {
                            self.sendMessageToContent({
                                action: 'showSystemNotification',
                                message: 'Your promo code has expired.'
                            }, function (resp) {
                                if (resp) {
                                    window.close();
                                }
                            });
                        } else {
                            // console.log(user);return;
                            chrome.tabs.create({
                                url: 'https://www.linkedin.com/sales/search',
                                //url: 'back-angular/dist/index.html#/user/connections',//'html/index.html',,chrome.tabs.executeScript( null, {user:self.userData})
                                active: true,
                            })
                        }
                    } else {
                        window.close();
                    }
                });
            });

            var mailto_handler = function () {
                var data_href = $(this).attr('data-href');

                self.sendMessageToContent({action: 'mailto_event', href: data_href});
            };

            $('span.mailto_link').unbind('click', mailto_handler).bind('click', mailto_handler);
        };
    }

    var app = new ExtSettings();
    app.run();

})(jQuery);
