/**
 * Progress Bar Wrapper
 * @param {int} total
 * @constructor
 */
var Progress = function(total) {

    var self = this;

    console.log('Progress bar inited with conunt', total);

    this.inProcess = true;

    this.total = total || 100;

    this.template = '<div class="ext-progress-bar">\
                        <div class="progress-bar-txt">\
                        <div class="progress-bar-title">Sending messages</div>\
                        <div class="progress-bar-body">Please wait.<br>Sending is in process...</div>\
                        </div>\
                        <div id="circle_progress_wrapper" class="c100 small" style="display: block">\
                        </div>\
                    </div>';

    $('body').append(this.template);

    this.circle = new ProgressBar.Circle('#circle_progress_wrapper', {
        color: '#2879BA',
        strokeWidth: 10,
        trailWidth: 10,
        easing: 'easeInOut',
        duration: 1400,
        text: {
            autoStyleContainer: false
        },
        from: {color: '#2879BA', width: 10},
        to: {color: '#2879BA', width: 10},
        step: function (state, circle, att) {

            var current = Math.round ( circle.value() * self.total )  ;

            circle.setText('<div id="ext_progress_slide_item_1" class="ext_progress_slide_item" title="Stop process"><img src="' +
                chrome.extension.getURL('/icons/close-button.png') + '"></div><div id="ext_progress_slide_item_2" class="ext_progress_slide_item">' +
                current + '/' + self.total + '</div>');
        }
    });

    /**
     * Check if process is in process
     * @returns {boolean}
     */
    this.isInProcess = function() {
        return self.inProcess;
    };

    this.setText = function(title, body1, body2) {
        var title = title || '',
        body = body || '';
        $('.progress-bar-title').html(title);
        $('.progress-bar-body').html(body1 + '<br>' + body2);
    };

    /**
     * Update Value in progress
     * @param {int} step - required
     */
    this.updateValue = function(step) {

        if ( step == undefined || typeof step !== 'number') {
            return false;
        } else {
            try {
                self.circle.animate(step / self.total);
            } catch (err) {
                return false;
            }

        }

    };

    /**
     * Destructor
     */
    this.stop = function() {

        self.circle.destroy();
        $('.ext-progress-bar').remove();
        self.inProcess = false;

    }

};