(function ($) {
    'use strict';

    // Send message to background script
    function sendMessageToBg(options, callback) {
        callback = callback || function () {
        };

        chrome.runtime.sendMessage(options, function (response) {
            console.log(response);

            if (response.plan) {
                callback(response);

            } else if (response.planErr) {
                $('body').text(response.planErr);

            } else if (response.err) {
                callback({msg: response.err});

            } else if (response.success) {
                callback({success: true, msg: 'Subscription successfully created.'});
            }
        });
    }

    // Stripe message state
    function stripeMsg() {
        //window.resizeTo(500, 160);
        $('html').css('border-top', '1px solid rgb(184, 184, 184)');
        document.title = 'Your payment status';

        var $stripe_msg_wrap = $('#stripe_msg_wrap');
        $stripe_msg_wrap.show();

        $('#submitButton', $stripe_msg_wrap).on('click', function () {
            window.close();
        });
        $('#rightCloseBtn', $stripe_msg_wrap).on('click', function () {
            window.close();
        });
    }

    sendMessageToBg({action: 'getPlanInfo'}, function (planInfo) {
        console.log(planInfo);

        var t = false;

        chrome.storage.local.get('coupon', function (data) {
            console.log(data);

            var amount = planInfo.plan.amount,
                couponId = false;

            if (!$.isEmptyObject(data)) {
                couponId = data.coupon;

                if (data.coupon.percentOff) {
                    amount = amount - (amount * data.coupon.percentOff / 100);

                } else if (data.coupon.amountOff) {
                    amount = amount - data.coupon.amountOff;
                }
            }

            var handler = StripeCheckout.configure({
                key: "pk_live_yGsUPfV9CPrVtjxDn67OPz9S",
                //key: "pk_test_eq4Ab4Fh9ylCo2DWAHHL7hDz",
                image: "http://5.9.42.61:8080/icons/icon.png",
                name: "LinkeLead",
                description: planInfo.plan.statement_descriptor,
                panelLabel: "Subscribe",
                amount: amount,
                allowRememberMe: false,
                token: function (token) {
                    console.log('token: ', token);

                    t = true;

                    stripeMsg();

                    sendMessageToBg({action: 'submitStripeForm', data: token, coupon: couponId}, function (response) {
                        handler.close();


                        $('#stripe_msg_area', $('#stripe_msg_wrap')).text(response.msg);
                    });

                },
                closed: function () {
                    if (!t) {
                        window.close();
                    }
                },
                error: function (err) {
                    console.log(err);

                    stripeMsg();
                    $('#stripe_msg_area', $('#stripe_msg_wrap')).text('Stripe request error. Please, try again later.');
                }
            });

            handler.open();

            chrome.storage.local.remove('coupon');
        });

    }, null);

})(jQuery);