$(document).ready(function(){

    var query = {
        start: 0,
        count: 10,
        fields: 'id,name,firstName,lastName,company,title,location,tags,emails,sources,displaySources,connectionDate,secureProfileImageUrl',
        sort: 'CREATED_DESC'
    }; // just for test

    var $table = $("#data-table-selection"); // table of connects

    var rowIds = []; // Array with selected rows

    /**
     * Get and set user name an picture on the page
     */
    /*chrome.storage.local.get('userInfo', function (response) {
        if(!chrome.runtime.lastError)
        {
            console.log('get', response);

            if( !$.isEmptyObject(response) ) {

                $('.user-box-name > p').html(response.userInfo.userName);
                $('.user-box-img img')
                    .attr('src', response.userInfo.photoSrc)
                    .attr('alt', response.userInfo.userName);

            } else {
                // emit some error
                $('#loading').addClass('hidden');
                $('#authorized').addClass('hidden');
                $('#unauthorized').removeClass('hidden');
            }


        } else {
            // emit some error
            $('#loading').addClass('hidden');
            $('#authorized').addClass('hidden');
            $('#unauthorized').removeClass('hidden');
            return;
        }

    });*/

    function renewLastRefreshDate() {
        chrome.runtime.sendMessage({
            action: 'getUserData'
        }, function (response) {
            if (!$.isEmptyObject(response)) {
                if (response.connections) {
                    if (response.connections.lastRefreshDate) {
                        var refreshDate = new Date(parseInt(response.connections.lastRefreshDate));

                        console.log(response.connections.lastRefreshDate);
                        console.log(refreshDate);

                        var stringDate = refreshDate.getMonth() + 1 + '-'
                            + refreshDate.getDate() + '-'
                            + refreshDate.getFullYear() + ' - '
                            + refreshDate.getHours() + ':'
                            + ( refreshDate.getMinutes() <= 9 ? ( '0' + refreshDate.getMinutes() ) : refreshDate.getMinutes() );

                        $('#last-refresh-date span').text(stringDate);
                    } else {
                        $('#last-refresh-date span').text('Not refreshed yet');
                    }
                } else {
                    $('#last-refresh-date span').text('Not refreshed yet');
                }
            }
        });
    }

    /**
     * Check if we are loggedIn and show table with user connects
     */

    var oldCookie;

    chrome.runtime.sendMessage({
        action: 'getUserData'
    }, function (response) {
        console.log(response);

            if (response.err) {
                // smth wrong
                $('#loading').addClass('hidden');
                $('#authorized').addClass('hidden');
                $('#unauthorized').removeClass('hidden');

            } else if (response.status == 'Not subscribed') {

                $('#loading').addClass('hidden');
                $('#authorized').addClass('hidden');
                $('#unauthorized').removeClass('hidden');

                $('.user-box-name > p').html(response.firstName + ' ' + response.lastName);
                $('.user-box-img img')
                    .attr('src', response.pictureUrl)
                    .attr('alt', response.firstName + ' ' + response.lastName);

            } else if (!$.isEmptyObject(response)) {

                $('.user-box-name > p').html(response.firstName + ' ' + response.lastName);
                $('.user-box-img img')
                    .attr('src', response.pictureUrl)
                    .attr('alt', response.firstName + ' ' + response.lastName);

                oldCookie = response.accessToken;

                $('#loading').addClass('hidden');
                $('#authorized').removeClass('hidden');

                if (response.connections) {
                    if (response.connections.lastRefreshDate) {
                        var refreshDate = new Date(parseInt(response.connections.lastRefreshDate));

                        console.log(response.connections.lastRefreshDate);
                        console.log(refreshDate);

                        var stringDate = _parseDate(refreshDate);

                        $('#last-refresh-date span').text(stringDate);
                    } else {
                        $('#last-refresh-date span').text('Not refreshed yet');
                    }
                } else {
                    $('#last-refresh-date span').text('Not refreshed yet');
                }



                if (response.status == 'In process') {
                    //self.subscribeInProcessState(); // Subscription is in process

                } else if (response.expirationDate > new Date().getTime() / 1000 || response.promoCode > new Date().getTime() / 1000) {
                    console.log('1', response.expirationDate > new Date().getTime() / 1000 , response.promoCode > new Date().getTime() / 1000)
                    //self.tabInit();

                    // draw table

                    // modalTags

                    loadTags(response.settings.tags);

                    initFilterTags(response.settings.tags);

                    chrome.runtime.sendMessage({
                        action: 'getSessionCookie'
                    }, function(response) {
                        if ( response ) {
                            //alert('In process');

                            console.log(response,'blabla');
                            initDT(response);

                        }
                    });

                    //initDT();

                    // init templates
                    if (response.settings.templates.m) {
                        initTmpl(response.settings.templates.m);
                    }



                } else {

                    //self.subscribeState(response.status); // Not subscribed
                }

            } else {

                // Not register or login
                $('#loading').addClass('hidden');
                $('#authorized').addClass('hidden');
                $('#unauthorized').removeClass('hidden');


            }


    });

    /**
     * Build table for user connects by access_token
     * @param access_token
     */

    //var domain = 'http://linkelead.dev';
    var domain = 'http://5.9.42.61';

    function initDT(session_cookie) {
        console.log(query,'query');

        //Selection
        $table.bootgrid({
            css: {
                icon: 'zmdi icon',
                iconColumns: 'zmdi-view-module',
                iconDown: 'zmdi-expand-more',
                iconRefresh: 'zmdi-refresh',
                iconUp: 'zmdi-expand-less'
            },
            ajaxSettings: {
                method: "GET",
                cache: false
            },
            ajax: true,
            url: domain + ':3000/api/v1/connections?session_cookie=' + session_cookie,

            requestHandler: function(request) {

                console.log('before send', request);

                // Transform request for LinkedIn API

                // i have current and rowCount


                request.skip = ( request.current * request.rowCount ) - request.rowCount;

                request.limit = request.rowCount + request.skip;

                request.sort_field = Object.keys(request.sort)[0];

                if( request.sort[request.sort_field] == 'desc' ) {
                    request.sort_field = '-' + request.sort_field;
                }

                //request.sort = 'last_name';

                request.keyword = request.searchPhrase;

                request.filter = filterTags;

                request.searchQueryType = 'name';
                //request.sort = 'CREATED_DESC';

                console.log('after transform', request);
                return request;

            },
            responseHandler: function(response) {

                console.log('response', response);


                // Transform response from LinkedIn API for Bootgrid
                var current;

                current = response.limit / ( response.limit - response.skip);

                for (var i = 0; i < response.data.length; i++) {
                    response.data[i].memberId = parseInt(response.data[i].memberId);
                }

                var newResponse =
                {
                    current: current,
                    rowCount: response.limit,
                    rows: response.data,
                    total: response.total
                };

                console.log(newResponse);

                return newResponse;
            },
            selection: true,
            multiSelect: true,
            rowSelect: true,
            keepSelection: true,
            formatters: {
                "u_name" : function(col, row){
                    var imageUrl;
                    imageUrl = row.profileImageUrl !== undefined ? 'src="' + row.profileImageUrl + '"' : 'src="../icons/user-avatar.jpg"' ;
                    return '<img ' + imageUrl + ' alt="user">' + '<span title="' + row[col.id] +'">' + row[col.id] +'</span>' + '<a href="' + row.profileUrl + '" title="See profile" target="_blank"><i class="zmdi zmdi-eye"></i></a>';
                },
                "u_company" : function(col, row){
                    if (row[col.id] !== undefined) {
                        return '<span class="text-cut" title="' + row[col.id] +'">' + row[col.id] +'</span>';
                    } else {
                        return '-';
                    }
                },
                "u_position" : function(col, row){
                    if (row[col.id] !== undefined) {
                        return '<span class="text-cut" title="' + row[col.id] + '">' + row[col.id] +'</span>';
                    } else {
                        return '-';
                    }
                },
                "u_location" : function(col, row){
                    if (row[col.id] !== undefined && row[col.id] != 0) {
                        return '<span class="text-cut" title="' + row[col.id] + '">' + row[col.id] +'</span>';
                    } else {
                        return '-';
                    }
                },
                "u_emails" : function(col, row){
                    if (row[col.id] == undefined || row[col.id] == 0 || row[col.id] == '0' ) {
                        return '-';
                    } else {
                        var emails = '';
                        row[col.id].forEach(function(email) {
                            emails += email.emailAddress + ', ';
                        });
                        //console.log(JSON.stringify(row[col.id]));
                        return '<span class="text-cut" title="' + emails.slice(0,-2) + '">' + emails.slice(0,-2) +'</span>';
                    }
                },
                "u_lastMessage" : function(col, row){
                    if (row[col.id] == undefined || row[col.id] == 0 || row[col.id] == '0' ) {
                        return '-';
                    } else {
                        var refreshDate = new Date( parseInt(row[col.id]) );
                            stringDate = refreshDate.getMonth()+1 + '-'
                            + refreshDate.getDate() + '-'
                            + refreshDate.getFullYear();
                        return '<span class="text-cut" title="' + stringDate + '">' + stringDate +'</span>';
                    }
                },
                "u_tags" : function(col, row){

                    var string = '',
                        sTitle = '';

                    if (row[col.id] && row[col.id].length !== 0 ) {
                        row[col.id].forEach(function(val, i) {
                            string += '<span>' + val + '</span>' + ', ';
                            sTitle += val + ', ';
                        });
                        return '<a class="u_link" title="' + sTitle.slice(0,-2) + '">' + string.slice(0,-2) + '</a>';
                    } else {
                        return '<a class="u_link title="-">-</a>';
                    }


                    //return '<a class="u_link" data-toggle="modal" ref="#modalTemplates">' + col.id + ', ' + col.id + ', ' + col.id + ', ' + col.id + ', ' + col.id + ', ' + col.id + ', ' + col.id + '</a>';
                }
            }
        }).on("loaded.rs.jquery.bootgrid", function (e) {

            /* Executes after data is loaded and rendered */
            $table.find('.u_link').on("click", function(e) {

                e.preventDefault();
                e.stopPropagation();
                // parse tags
                var tags = [];

                console.log($(e.target));

                $(e.target).closest('.u_link').find('span').each(function(i, el) {
                    tags.push($(el).html());
                    console.log($(el).html());
                });

                console.log(tags);

                $('#modalTags').modal('show');

                $(e.target).closest('tr').find('.u_name').data('id', $(e.target).closest('tr').data('row-id'));

                $('#modalTags #assign-to-single')
                    .text('to ' + $(e.target).closest('tr').find('.u_name').text())
                    .data('id', $(e.target).closest('tr').data('row-id'));

                checkTags(tags);

            });

            $table.find('.u_name a').on('click', function(e) {
                console.log(e.target);
                e.stopPropagation();
                e.stopImmediatePropagation();
            });

        }).on("selected.rs.jquery.bootgrid", function(e, rows) {

            console.log(e);
            for (var i = 0; i < rows.length; i++) {

                // save selected connection
                rowIds.push([rows[i].memberId, rows[i].firstName]);

            }

            updateSelectedRowsPanel();
            //alert("Select: " + rowIds.join(","));
            console.log(rowIds);


        }).on("deselected.rs.jquery.bootgrid", function(e, rows) {

            for (var i = 0; i < rows.length; i++) {

                // delete selected connection
                var index = -1;

                rowIds.forEach(function(v, ii) {

                    if ( v[0] == rows[i].memberId ) {
                        index = ii;
                    }

                });

                if(index != -1) rowIds.splice(index, 1);

            }

            updateSelectedRowsPanel();
            //alert("Deselect: " + rowIds.join(","));
            console.log(rowIds);

        });
    }

    /**
     * Build templates
     * @param {Array} templates - Array of templates [{b: 'Body Message', s: 'Subject and name of template'}]
     */

    var $tmplList = $('#templates-list');

    function initTmpl(templates) {
        console.log(templates);

        if (templates.length > 0) {

            $tmplList.find('li > a').text(''); //clear default placeholder

            var htmlTemplate = $tmplList.find('li').clone(); //remember item template
            console.log(htmlTemplate);
            $tmplList.html(''); //clear default item

            // add templates to list
            for (var i = templates.length - 1; i >= 0; i--) {

                var newItem = $(htmlTemplate).clone();

                newItem.find('a').text(templates[i].s);
                newItem.find('a').data('subject', templates[i].s);
                newItem.find('a').data('body', templates[i].b);

                // add event for applying template
                newItem.on('click', function(e) {

                    console.log('Theme message: ' + $(e.target).data('subject') + ';/n Body Message: ' + $(e.target).data('body') );

                    $('#message-subject').val($(e.target).data('subject')).focus();
                    $('#message-body').val($(e.target).data('body')).focus();

                });

                $tmplList.append(newItem);

            }

        }

    }

    /**
     * Load Tags
     */

    var $template = $('#modalTags .list-group').find('li').eq(0).clone();
    function loadTags(tags) {

        if( $('#modalTags').css('display') == 'none' ) {
            $('#assign-to-single').text('').data('id', '');
        }

        $('#input-add-tag').val('');


        var tags = tags || [],
            $tmplWrap = $('#modalTags .list-group');

        // clear
        $tmplWrap.html('');

        //tags.forEach(function(val, i) {
        for(var i = tags.length - 1; i >= 0; i--) {

            var $item = $template.clone();
            $item.find('label span').text(tags[i]);
            $item.find('input').val(tags[i]);

            console.log('inserted ', tags[i]);
            $tmplWrap.append($item);

        }


        console.log($template);
    }

    function checkTags(tags) {

        var tags = tags || [],
            $tmplWrap = $('#modalTags .list-group');

        $tmplWrap.find('input').prop('checked', false);

        $tmplWrap.find('li').each(function(i, el) {
            tags.forEach(function(val) {
                if ( $(el).find('input').val() ==  val ) {
                    $(el).find('input').prop('checked', 'checked');
                }
            });
        });

    }

    $('#assignTags').on('click', function(e) {

        chrome.runtime.sendMessage({
            action: 'getUserData'
        }, function (response) {

            loadTags(response.settings.tags);
            $('#modalTags').modal('show');
        });

    });



    $('#add-tag').on('click', function(e) {
        addNewTag();
    });

    $('#input-add-tag').on('keydown', function(e) {
        $(e.target).closest('.form-group').removeClass('has-error');
        if (e.keyCode == 13) {
            e.preventDefault();
            addNewTag();
        }
    });

    function addNewTag() {
        var $inputTag = $('#input-add-tag'),
            newTag = $inputTag.val();

        if (newTag != '') {

            chrome.runtime.sendMessage({
                action: 'getSessionCookie'
            }, function (response) {
                if (response) {
                    //alert('In process');

                    console.log(response);
                    var session_cookie = response;

                    chrome.runtime.sendMessage({
                        action: 'getUserData'
                    }, function (response) {

                        var userData = response;

                        if (userData.settings.tags.indexOf(newTag) !== -1) {
                            // alertify.notify('Tag already exists', 'error', 5);
                        } else {

                            userData.settings.tags.push(newTag);

                            console.log(userData.settings.tags);

                            $.ajax({
                                    url: domain + ':3000/api/v1/updateSettings',
                                    method: 'PUT',
                                    data: {
                                        sessionCookie: session_cookie,
                                        settings: userData.settings
                                    }
                                })
                                .done(function () {

                                    var tagsValue = [];
                                    $('#modalTags .list-group-item input:checked').each(function () {
                                        tagsValue.push($(this).val());
                                        console.log(tagsValue);
                                    });

                                    tagsValue.push(newTag);

                                    loadTags(userData.settings.tags);

                                    initFilterTags(userData.settings.tags);

                                    checkTags(tagsValue);
                                })
                                .error(function () {

                                    console.error('Error adding tags');
                                    // alertify.notify('Can\'t add tag', 'error', 5);

                                });


                        }

                    });

                }
            });
        } else {

            $inputTag.focus().closest('.form-group').addClass('has-error');
            // alertify.notify('Tag field is empty', 'error', 5);

        }
    }

    $('#assign-tag-btn').on('click', function(e) {

        chrome.runtime.sendMessage({
            action: 'getSessionCookie'
        }, function(response) {

            if ( response ) {

                var session_cookie = response,
                    members = [];

                rowIds.forEach(function( val, i ) {
                    console.log(val);
                    members.push(val[0]);
                });

                var tagsValue = [];
                $('#modalTags .list-group-item input:checked').each(function() {
                    tagsValue.push( $(this).val() );
                });



                if ($('#assign-to-single').data('id')) {

                    $.ajax({
                            url: domain + ':3000/api/v1/updateTagsForUserConnection',
                            method: 'PUT',
                            data: {
                                sessionCookie: session_cookie,
                                memberId: $('#assign-to-single').data('id'),
                                tags: tagsValue
                            }
                        })
                        .done(function() {
                            //alert('ok');
                            $table.bootgrid('reload');

                        })
                        .error(function() {
                            //alert('no');
                        });

                } else {
                    if (tagsValue.length > 0) {
                        $.ajax({
                                url: domain + ':3000/api/v1/saveTagsForUserConnection',
                                method: 'POST',
                                data: {
                                    sessionCookie: session_cookie,
                                    memberId: members,
                                    tags: tagsValue
                                }
                            })
                            .done(function () {
                                //alert('ok');
                                $table.bootgrid('reload');

                            })
                            .error(function () {
                                //alert('no');
                            });
                    }
                }


            }

        });

    });

    /**
     * Filter tags
     */

    var filterTags = [];

    function initFilterTags(tags) {

        var tags = tags || [],
            $filter = $('#filter-tags-wrap .selectpicker');

        $filter.html('');

        for (var i = tags.length - 1; i >= 0; i-- ) {
            $filter.append('<option value ="' + tags[i] + '">' + tags[i] + '</option>');
        }

        setTimeout (function() {
            $filter.selectpicker('refresh');
        }, 100);

        $filter.on('change', function(e) {

            console.log(e);
            filterTags = $filter.val();
            console.log( filterTags );

            $table.bootgrid('reload');

        })

    }

    /**
     * Send Messages
     */

    // Validation for inputs
    $('#message-subject, #message-body, #input-add-tag').on('keydown focus', function(e) {
            $(e.target).closest('.form-group').removeClass('has-error');
    });

    var progress;

    /**
     * Check if messaging in process
     */

    chrome.runtime.sendMessage({
        action: 'checkMessagingProcess'
    }, function(response) {
        if ( response ) {
            //alert('In process');

            if ( !(progress && progress.isInProcess()) ) {
                progress = new Progress(response.total);
                progress.setText('Sending messages', 'Please wait', 'Sending is in process...');
                progress.updateValue(response.i);
            }

        }
    });


    ///////////////////

    $('#message-send').on('click', function(e) {

        var $subject = $('#message-subject'),
            $body = $('#message-body');

        if ( $subject.val().length <= 0 ) {

            // alertify.notify('Empty message subject', 'error', 5);
            $subject.focus().closest('.form-group').addClass('has-error');
            return false;
        }

        if ( $body.val().length <= 0 ) {
            // alertify.notify('Empty message body', 'error', 5);
            $body.focus().closest('.form-group').addClass('has-error');
            return false;
        }

        if ( progress && progress.isInProcess() ) {
            // alertify.notify('Messaging are in process', 'error', 5);
            return false;
        }

        chrome.runtime.sendMessage({
            action: 'sendMessageToConnections',
            data: {
                connectionIds: rowIds,
                subject: $subject.val(),
                body: $body.val()
            }
        }, function(response) {
            console.log(response);
            progress = new Progress(response);
            progress.setText('Sending messages', 'Please wait', 'Sending is in process...');
            console.log(progress.circle);
        });


    });

    $(document).on('click', '#ext_progress_slide_item_1', function(e) {


        console.log('clicked');
        chrome.runtime.sendMessage({
            action: 'cancelMessaging'
        }, function(response) {

            console.log(response);

            if (response !== 'cancelRefresh') {
                console.log(response);
                // alertify.notify('You have stopped the process', 'success', 5);
                progress.stop();
                unBlockUI();
            }

        });


    });

    $('#refresh-connections').on('click', function(e) {

        blockUI();

        chrome.runtime.sendMessage({
            action: 'makeFullRefresh'
        }, function(response) {

            if( response && response.action == 'start' ) {

                console.log('Full Refresh started');
                //progress = new Progress(response.total);

            } else if ( response && response.action == 'finished' ) {

                console.log('Full Refresh finished');

                unBlockUI();

            } else {
                console.error('Can\'t refresh');

                unBlockUI();
            }


        });

    });

    $('#fast-refresh-connections').on('click', function(e) {

        blockUI();

        chrome.runtime.sendMessage({
            action: 'makeFastRefresh'
        }, function(response) {

            if(response == 'finished') {
                // alertify.notify('Quick refresh completed', 'success', 5);
                unBlockUI();
            } else {
                // alertify.notify('Quick refresh completed', 'success', 5);
                unBlockUI();
            }

        });

    });

    function blockUI() {
        $('.header-sub-control .dropdown-toggle, #assignTags, #sendMsg').attr('disabled', 'disabled');
    }

    function unBlockUI() {
        $('.header-sub-control .dropdown-toggle, #assignTags, #sendMsg').attr('disabled', false);
    }

    /**
     * Event Listening
     */
    chrome.runtime.onMessage.addListener(
        function (request, sender, sendResponse) {
            //console.log(request.action);

            if (request.action == 'updateMessaging') {
                console.log(request);
                console.log(progress);

                blockUI();

                if ( progress && progress.isInProcess() ) {
                    progress.updateValue(request.i + 1);
                } else {

                    console.log(request);

                    progress = new Progress(request.total);
                    progress.setText('Sending messages', 'Please wait', 'Sending is in process...');
                    progress.updateValue(request.i + 1);
                }



            } else if (request.action == 'stopMessaging') {

                setTimeout(function() {
                    // alertify.notify('All messages sent', 'success', 5);
                    progress.stop();
                    unBlockUI();
                }, 1500);


            } else if (request.action == 'canceledMessaging') {

                unBlockUI();

            } else if (request.action == 'erroredMessaging') {

                // alertify.notify('Can\'t send messages, please try again later', 'error', 5);
                progress.stop();
                unBlockUI();
                console.log(progress.circle);

            } else if (request.action == 'fullRefreshStarted') {

                progress = new Progress(request.total);
                progress.setText('Refreshing contacts', 'Please wait', 'Refreshing is in process...');

            } else if (request.action == 'fullRefreshUpdated') {

                blockUI();

                if ( progress && progress.isInProcess() ) {
                    progress.updateValue(request.value);
                } else {

                    console.log(request);

                    progress = new Progress(request.total);
                    progress.setText('Refreshing contacts', 'Please wait', 'Refreshing is in process...');
                    progress.updateValue(request.value);
                }


            } else if (request.action == 'fullRefreshStoped') {

                // alertify.notify('Full refresh completed', 'success', 5);
                unBlockUI();
                renewLastRefreshDate();
                progress.stop();
                $table.bootgrid('reload');

            } else if (request.action == 'fullRefreshInterrupted') {

                // alertify.notify('Full refresh canceled', 'success', 5);
                unBlockUI();
                renewLastRefreshDate();
                progress.stop();
                $table.bootgrid('reload');
            }

            return true;
        });

    /**
     * Update Panel of selected rows
     */

    $('#selected-rows-clear').on('click', function(e) {
        e.preventDefault();

        var deselectRows = [];

        rowIds.forEach(function(val, i) {
            deselectRows.push(val[0]);
        });

        console.log(deselectRows);

        rowIds = [];

        $table.bootgrid('deselectAll');
        updateSelectedRowsPanel();
    });

    function updateSelectedRowsPanel() {
        var count = rowIds.length;
        if ( count > 0 ) {
            //$srPanel.show();

            $('.header-sub').removeClass('hidden');
            $('.header-sub_base').addClass('hidden');
            $('.header-sub-wrap').addClass('bgm-sea');

            $('#selected-rows-count').text(count);
        } else {
            //$srPanel.hide();
            $('.header-sub').addClass('hidden');
            $('.header-sub_base').removeClass('hidden');
            $('.header-sub-wrap').removeClass('bgm-sea');
        }
    }

    /*
     * Waves Animation
     */
    (function(){
        Waves.attach('.btn:not(.btn-icon):not(.btn-float)');
        Waves.attach('.btn-icon, .btn-float', ['waves-circle', 'waves-float']);
        Waves.init();
    })();

    /*
     * Text Feild
     */

    //Add blue animated border and remove with condition when focus and blur
    if($('.fg-line')[0]) {
        $('body').on('focus', '.fg-line .form-control', function(){
            $(this).closest('.fg-line').addClass('fg-toggled');
        })

        $('body').on('blur', '.form-control', function(){
            var p = $(this).closest('.form-group, .input-group');
            var i = p.find('.form-control').val();

            if (p.hasClass('fg-float')) {
                if (i.length == 0) {
                    $(this).closest('.fg-line').removeClass('fg-toggled');
                }
            }
            else {
                $(this).closest('.fg-line').removeClass('fg-toggled');
            }
        });
    }

    /*
     * Fixed control header on scroll
     */
    var $wrapFix = $("#header");

    $(window).on("scroll", function(e) {
        if (window.scrollY > 65) {
            $wrapFix.addClass("header-fix");
        } else {
            $wrapFix.removeClass("header-fix");
        }

    });

    $('#modalTemplates').on('shown.bs.modal', function() {
        $('.modal input[type=text], .modal textarea').val('');
        $('.modal input[type=text]').focus();
    });

    $(document).on('click', function() {

        chrome.runtime.sendMessage({
            action: 'getUserData'
        }, function(response) {
            console.log(response);
            console.log(oldCookie);
            if (!oldCookie) oldCookie = response.accessToken;

            //console.log(response);

            if ($.isEmptyObject(response) || oldCookie !== response.accessToken) {
                window.location.reload();

            }
        });
    });

    function _downloadFile() {

        chrome.runtime.sendMessage({
            action: 'getToken'
        }, function(response) {

            var url = 'https://www.linkedin.com/people/export-action?outputType=microsoft_outlook&csrfToken=' + encodeURIComponent(response);

            //$('#download-btn').attr('href', url);

            chrome.windows.create({
                url: url,
                type: 'popup',
                width: 460,
                height: 400
            }, function(win) {

                console.log(win);

                console.log(win.id);

                var winId = win.id;

                (function(winId){

                    chrome.tabs.query({
                        windowId: winId
                    }, function(tabs) {
                        console.log(tabs[0]);
                        chrome.tabs.insertCSS(tabs[0].id, {
                            code: "#header {display:none} #footer {display:none} "
                        });

                        chrome.tabs.onUpdated.addListener(_addListenerCSS);

                        chrome.downloads.onChanged.addListener(_addListenerDownload);

                        function _addListenerCSS(tabId, changeInfo, tab) {
                            if (tabId == tabs[0].id) {
                                console.log(changeInfo);

                                if (changeInfo.status && changeInfo.status === 'loading') {
                                    chrome.tabs.insertCSS(tabs[0].id, {
                                        code: "#header {display:none} #footer {display:none} "
                                    });
                                }
                            }
                        }

                        function _addListenerDownload(downloadItem) {
                            console.log(downloadItem);

                            if (downloadItem.endTime && downloadItem.state && downloadItem.state.current && downloadItem.state.current === 'complete') {

                                chrome.windows.remove(winId);

                                chrome.downloads.onChanged.removeListener(_addListenerDownload);
                                chrome.tabs.onUpdated.removeListener(_addListenerCSS);
                                console.log(winId);

                                //chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
                                //    chrome.tabs.sendMessage(tabs[0].id, {
                                //        action: 'showSuccessNotification',
                                //        message: 'Download connections completed'
                                //    });
                                //});

                                // alertify.notify('Downloading finished', 'success', 5);
                            }
                        }

                    })

                })(winId);

            });

        });

    }


    $('#download-btn').on('click', function(e) {
        e.preventDefault();
        _downloadFile();
    });

    function _parseDate(date) {
        if ( !(date instanceof Date) ) {
            return false;
        }
        return date.getMonth() + 1 + '-'
        + date.getDate() + '-'
        + date.getFullYear() + ' - '
        + date.getHours() + ':'
        + ( date.getMinutes() <= 9 ? ( '0' + date.getMinutes() ) : date.getMinutes() );
    }

    //document.querySelectorAll('#download-list a').addEventListener('click', function() {
    //    setDownloadLinks();
    //}, false);

    //
    //$.get('https://www.linkedin.com/people/export-action?outputType=microsoft_outlook&csrfToken=ajax%3A4592665502933212045')
    //    .done(function (response) {
    //        console.log(response)
    //    })
    //    .error(function (response) {
    //
    //    });


});